/*******************************************************
Chip type               : ATtiny13A
AVR Core Clock frequency: 9,600000 MHz
*******************************************************/

#include <tiny13a.h>
#include <delay.h>

volatile unsigned char servo_1=90; //     0  180  . 90 -  
volatile unsigned char servo_2=90; //     0  180  . 90 -  


// Timer 0 output compare A interrupt service routine
interrupt [TIM0_COMPA] void timer0_compa_isr(void)
{
 static unsigned char step=0;
 static unsigned int counter=0;
 switch(step)
       {
        case 0:                        //       900    (6,666 *135       )
               counter=134;
               OCR0A=134;
               step++;
               break;
               
        case 1:
               PORTB.0=1;              //      900  (6,666 *135)
               counter+=133;
               OCR0A=133;
               step++;
               if (servo_1==0) step++; //   
               break; 
                           
        case 2:
               counter+=servo_1;      //      -    6,666   1 
               OCR0A=servo_1;
               step++;
               break;
                 
        case 3:  
               PORTB.0=0;             //          900  (6,666 *135)
               PORTB.1=1;
               counter+=133;
               OCR0A=133;
               step++;                
               if (servo_2==0) step++;//   
               break;
               
        case 4:
               counter+=servo_2;     //      -    6,666   1 
               OCR0A=servo_2;
               step++;
               break;                  

        case 5:
               PORTB.1=0;            //       1,7 
               counter+=255;
               OCR0A=255;
               step++;
               break; 
               
        case 6:
               if (counter<2730U)    //     20  
                  {
                   counter+=255;
                   OCR0A=255;
                  } else
                        {  
                         OCR0A=2985U-counter;
                         step=0;
                        }
               break; 
                 
       }   
      
}

void main(void)
{


// Input/Output Ports initialization
// Port B initialization
// Function: Bit5=In Bit4=In Bit3=In Bit2=In Bit1=Out Bit0=Out 
DDRB=(0<<DDB5) | (0<<DDB4) | (0<<DDB3) | (0<<DDB2) | (1<<DDB1) | (1<<DDB0);
// State: Bit5=P Bit4=P Bit3=P Bit2=P Bit1=0 Bit0=0 
PORTB=(1<<PORTB5) | (1<<PORTB4) | (1<<PORTB3) | (1<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 150,000 kHz
// Mode: CTC top=OCR0A
// OC0A output: Disconnected
// OC0B output: Disconnected
// Timer Period: 6,6667 us
TCCR0A=(0<<COM0A1) | (0<<COM0A0) | (0<<COM0B1) | (0<<COM0B0) | (1<<WGM01) | (0<<WGM00);
TCCR0B=(0<<WGM02) | (0<<CS02) | (1<<CS01) | (1<<CS00);
TCNT0=0x00;
OCR0A=10;
OCR0B=0x00;


// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=(0<<OCIE0B) | (1<<OCIE0A) | (0<<TOIE0);


// Global enable interrupts
#asm("sei")

while (1)
      {          
        //  
       if(PINB.2==0)
         { 
          delay_ms(15);
          if(PINB.2==0)
            {
             if(servo_1>0) servo_1--;

            }
         }                 
         
       if(PINB.4==0)
         { 
          delay_ms(15);
          if(PINB.4==0)
            {
             if(servo_1<180) servo_1++;

            }
         }
         
       if(PINB.3==0)
         { 
          delay_ms(15);
          if(PINB.3==0)
            {
             if(servo_2>0) servo_2--;

            }
         }
           
       if(PINB.5==0)
         { 
          delay_ms(15);
          if(PINB.5==0)
            {
             if(servo_2<180) servo_2++;

            }
         }               
      }
}
